hdu 1561 The more, The Better 树状DP
来源:程序员人生 发布时间:2015-05-11 08:59:25 阅读次数:2688次
The more, The Better
Time Limit: 6000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5844 Accepted Submission(s): 3476
Problem Description
ACboy很喜欢玩1种战略游戏,在1个地图上,有N座城堡,每座城堡都有1定的宝物,在每次游戏中ACboy允许攻克M个城堡并取得里面的宝物。但由于地理位置缘由,有些城堡不能直接攻克,要攻克这些城堡必须先攻克其他某1个特定的城堡。你能帮ACboy算出要取得尽可能多的宝物应当攻克哪M个城堡吗?
Input
每一个测试实例首先包括2个整数,N,M.(1 <= M <= N <= 200);在接下来的N行里,每行包括2个整数,a,b. 在第 i 行,a 代表要攻克第 i 个城堡必须先攻克第 a 个城堡,如果 a = 0 则代表可以直接攻克第 i 个城堡。b 代表第 i 个城堡的宝物数量, b >= 0。当N = 0, M = 0输入结束。
Output
对每一个测试实例,输出1个整数,代表ACboy攻克M个城堡所取得的最多宝物的数量。
Sample Input
3 2
0 1
0 2
0 3
7 4
2 2
0 1
0 4
2 1
7 1
7 6
2 2
0 0
Sample Output
Author
8600
Source
HDU 2006⑴2 Programming Contest
链接:http://acm.hdu.edu.cn/showproblem.php?pid=1561
做法:设1个0节点,本身价值是0,dp[i][j]表示第i个节点,取了j个节点后的价值。由于先取父亲才能取儿子,所以要从dp[i][1] 开始转移。把子节点的状态转移到父亲节点。
由于和分组背包1样,子节点不能重复更新父亲节点,所之外层循环父节点状态,从大到小,内层循环子节点状态。
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <malloc.h>
#include <ctype.h>
#include <math.h>
#include <string>
#include <iostream>
#include <algorithm>
using namespace std;
#include <stack>
#include <queue>
#include <vector>
#include <deque>
#include <set>
#include <map>
#define INF 999999999
#define eps 0.00001
#define LL __int64d
#define pi acos(⑴.0)
vector<int> son[210];
int dp[210][210];
int val[210];
int n,m;
void dfs(int nw)
{
//dp[nw][0]=0;
dp[nw][1]=val[nw];
for(int i=0;i<son[nw].size();i++)
{
dfs(son[nw][i]);
int ss=son[nw][i];
for(int k=m;k>=1;k--)
{
if(dp[nw][k]!=⑴)
{
for(int j=1;j<=m;j++)
{
if(dp[ss][j]==⑴)
break;
dp[nw][j+k]=max(dp[ss][j]+dp[nw][k],dp[nw][j+k]);
}
}
}
}
}
int main()
{
while(scanf("%d%d",&n,&m),n||m)
{
memset(dp,⑴,sizeof dp);
for(int i=0;i<=n;i++)
{
son[i].clear();
}
val[0]=0;
for(int i=1;i<=n;i++)
{
int a,b;
scanf("%d%d",&a,&val[i]);
son[a].push_back(i);
}
dfs(0);
printf("%d
",dp[0][m+1]);
}
return 0;
}
生活不易,码农辛苦
如果您觉得本网站对您的学习有所帮助,可以手机扫描二维码进行捐赠